function read
openr,1,'time.info'
nt=0
readf,1,nt
close,1
time=dblarr(nt+1)
openr,1,'time.out'
readf,1,time
close,1
;
; Read the gas disk structure
;
openr,1,'diskstruct.inp'
nr=0
nz=0
readf,1,nr,nz
data=dblarr(5,nz,nr)
readf,1,data
close,1
r=dblarr(nr)
z=dblarr(nz,nr)
rhogas=dblarr(nz,nr)
tgas=dblarr(nz,nr)
r[*]        = data[0,0,*]
z[*,*]      = data[1,*,*]
rhogas[*,*] = data[2,*,*]
tgas[*,*]   = data[3,*,*]
;
; Read the dust disk structure, iff dustdens.inp is present
;
q=file_search('dustdens.inp',count=count)
if count ge 1 then begin
   openr,1,'dustdens_000.out'
   iformat=0
   readf,1,iformat
   i=0
   j=0
   ns=0
   readf,1,i,j
   if i ne nr or j ne nz then stop
   readf,1,ns
   close,1
   rhodust = dblarr(ns,nz,nr,nt+1)
   data    = dblarr(ns,nz,nr)
   for it=0,nt do begin
      str=strcompress(string(it),/remove_all)
      ndig=3
      q=10L
      for k=1,ndig-1 do begin
         if it lt q then str='0'+str
         q=q*10
      endfor
      file='dustdens_'+str+'.out'
      openr,1,file
      i=0
      j=0
      k=0
      l=0
      readf,1,i
      readf,1,j,k
      readf,1,l
      if i ne 1 or j ne nr or k ne nz or l ne ns then stop
      readf,1,data
      rhodust[*,*,*,it] = data[*,*,*]
      close,1
   endfor
endif else begin
   rhodust = 0
endelse
;
; Read the chem disk structure, iff chemdens.inp is present
;
q=file_search('chemdens.inp',count=count)
if count ge 1 then begin
   openr,1,'chemdens_000.out'
   iformat=0
   readf,1,iformat
   i=0
   j=0
   ns=0
   readf,1,i,j
   if i ne nr or j ne nz then stop
   readf,1,ns
   close,1
   rhochem = dblarr(ns,nz,nr,nt+1)
   data    = dblarr(ns,nz,nr)
   for it=0,nt do begin
      str=strcompress(string(it),/remove_all)
      ndig=3
      q=10L
      for k=1,ndig-1 do begin
         if it lt q then str='0'+str
         q=q*10
      endfor
      file='chemdens_'+str+'.out'
      openr,1,file
      i=0
      j=0
      k=0
      l=0
      readf,1,i
      readf,1,j,k
      readf,1,l
      if i ne 1 or j ne nr or k ne nz or l ne ns then stop
      readf,1,data
      rhochem[*,*,*,it] = data[*,*,*]
      close,1
   endfor
endif else begin
   rhochem = 0
endelse
return,{time:time,r:r,z:z,rhodust:rhodust,rhochem:rhochem,rhogas:rhogas,tgas:tgas}
end

